BuilderBasedDeserializer
Date: 2016-12-04

com.fasterxml.jackson.databind.deser

## Class BuilderBasedDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<java.lang.Object>
    - - com.fasterxml.jackson.databind.deser.BeanDeserializerBase
      - - com.fasterxml.jackson.databind.deser.BuilderBasedDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, ResolvableDeserializer, java.io.Serializable

      public class BuilderBasedDeserializer
      extends BeanDeserializerBase

  Class that handles deserialization using a separate Builder class, which is used for data binding and produces actual deserialized value at the end of data binding.

  Note on implementation: much of code has been copied from `BeanDeserializer`; there may be opportunities to refactor this in future.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AnnotatedMethod` | `_buildMethod`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

      `_anySetter, _arrayDelegateDeserializer, _backRefs, _beanProperties, _beanType, _delegateDeserializer, _externalTypeIdHandler, _ignorableProps, _ignoreAllUnknown, _injectables, _needViewProcesing, _nonStandardCreation, _objectIdReader, _propertyBasedCreator, _serializationShape, _subDeserializers, _unwrappedPropertyHandler, _valueInstantiator, _vanillaProcessing, TEMP_PROPERTY_NAME`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `BuilderBasedDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, BeanPropertyMap properties, java.util.Map<java.lang.String,SettableBeanProperty> backRefs, java.util.Set<java.lang.String> ignorableProps, boolean ignoreAllUnknown, boolean hasViews)` Constructor used by `BeanDeserializerBuilder`.
    `protected` | `BuilderBasedDeserializer(BuilderBasedDeserializer src)` Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
    `` | `BuilderBasedDeserializer(BuilderBasedDeserializer src, BeanPropertyMap props)`
    `protected` | `BuilderBasedDeserializer(BuilderBasedDeserializer src, boolean ignoreAllUnknown)`
    `protected` | `BuilderBasedDeserializer(BuilderBasedDeserializer src, NameTransformer unwrapper)`
    `` | `BuilderBasedDeserializer(BuilderBasedDeserializer src, ObjectIdReader oir)`
    `` | `BuilderBasedDeserializer(BuilderBasedDeserializer src, java.util.Set<java.lang.String> ignorableProps)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.Object` | `_deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object builder)`
    `protected java.lang.Object` | `_deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters.
    `protected BeanDeserializerBase` | `asArrayDeserializer()` Fluent factory for creating a variant that can handle POJO output as a JSON Array.
    `java.lang.Object` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Main deserialization method for bean-based objects (POJOs).
    `java.lang.Object` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object builder)` Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.
    `java.lang.Object` | `deserializeFromObject(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` General version used when handling needs more advanced features.
    `protected java.lang.Object` | `deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `protected java.lang.Object` | `deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `protected java.lang.Object` | `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `protected java.lang.Object` | `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object bean)`
    `protected java.lang.Object` | `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method called when there are declared "unwrapped" properties which need special handling
    `protected java.lang.Object` | `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object bean)`
    `protected java.lang.Object` | `deserializeWithView(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object bean, java.lang.Class<?> activeView)`
    `protected java.lang.Object` | `finishBuild(DeserializationContext ctxt, java.lang.Object builder)`
    `JsonDeserializer<java.lang.Object>` | `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.
    `BeanDeserializerBase` | `withBeanProperties(BeanPropertyMap props)` Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.
    `BeanDeserializerBase` | `withIgnorableProperties(java.util.Set<java.lang.String> ignorableProps)`
    `BeanDeserializerBase` | `withObjectIdReader(ObjectIdReader oir)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

      `_convertObjectId, _findSubclassDeserializer, _handleTypedObjectId, _resolvedObjectIdProperty, _resolveInnerClassValuedProperty, _resolveManagedReferenceProperty, _resolveUnwrappedProperty, createContextual, creatorProperties, deserializeFromArray, deserializeFromBoolean, deserializeFromDouble, deserializeFromEmbedded, deserializeFromNumber, deserializeFromObjectId, deserializeFromObjectUsingNonDefault, deserializeFromString, deserializeWithObjectId, deserializeWithType, findBackReference, findConvertingDeserializer, findProperty, findProperty, findProperty, getBeanClass, getKnownPropertyNames, getObjectIdReader, getPropertyCount, getValueInstantiator, getValueType, handledType, handleIgnoredProperty, handlePolymorphic, handleUnknownProperties, handleUnknownProperty, handleUnknownVanilla, hasProperty, hasViews, injectValues, isCachable, properties, replaceProperty, resolve, wrapAndThrow, wrapAndThrow, wrapInstantiationProblem`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _hasTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromInt, _parseBooleanFromOther, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, getValueClass, handleMissingEndArrayForSingle, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `getDelegatee, getEmptyValue, getEmptyValue, getNullValue, getNullValue, replaceDelegatee`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _buildMethod

          protected final AnnotatedMethod _buildMethod

  - ### Constructor Detail

    - #### BuilderBasedDeserializer

          public BuilderBasedDeserializer(BeanDeserializerBuilder builder,
                                  BeanDescription beanDesc,
                                  BeanPropertyMap properties,
                                  java.util.Map<java.lang.String,SettableBeanProperty> backRefs,
                                  java.util.Set<java.lang.String> ignorableProps,
                                  boolean ignoreAllUnknown,
                                  boolean hasViews)

      Constructor used by `BeanDeserializerBuilder`.

    - #### BuilderBasedDeserializer

          protected BuilderBasedDeserializer(BuilderBasedDeserializer src)

      Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.

    - #### BuilderBasedDeserializer

          protected BuilderBasedDeserializer(BuilderBasedDeserializer src,
                                  boolean ignoreAllUnknown)

    - #### BuilderBasedDeserializer

          protected BuilderBasedDeserializer(BuilderBasedDeserializer src,
                                  NameTransformer unwrapper)

    - #### BuilderBasedDeserializer

          public BuilderBasedDeserializer(BuilderBasedDeserializer src,
                                  ObjectIdReader oir)

    - #### BuilderBasedDeserializer

          public BuilderBasedDeserializer(BuilderBasedDeserializer src,
                                  java.util.Set<java.lang.String> ignorableProps)

    - #### BuilderBasedDeserializer

          public BuilderBasedDeserializer(BuilderBasedDeserializer src,
                                  BeanPropertyMap props)

  - ### Method Detail

    - #### unwrappingDeserializer

          public JsonDeserializer<java.lang.Object> unwrappingDeserializer(NameTransformer unwrapper)

      Description copied from class: `JsonDeserializer`
      Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

      Default implementation just returns 'this' indicating that no unwrapped variant exists

      Specified by:
        `unwrappingDeserializer` in class `BeanDeserializerBase`

    - #### withObjectIdReader

          public BeanDeserializerBase withObjectIdReader(ObjectIdReader oir)

      Specified by:
        `withObjectIdReader` in class `BeanDeserializerBase`

    - #### withIgnorableProperties

          public BeanDeserializerBase withIgnorableProperties(java.util.Set<java.lang.String> ignorableProps)

      Specified by:
        `withIgnorableProperties` in class `BeanDeserializerBase`

    - #### withBeanProperties

          public BeanDeserializerBase withBeanProperties(BeanPropertyMap props)

      Description copied from class: `BeanDeserializerBase`
      Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.
      Overrides:
        `withBeanProperties` in class `BeanDeserializerBase`

    - #### asArrayDeserializer

          protected BeanDeserializerBase asArrayDeserializer()

      Description copied from class: `BeanDeserializerBase`
      Fluent factory for creating a variant that can handle POJO output as a JSON Array. Implementations may ignore this request if no such input is possible.
      Specified by:
        `asArrayDeserializer` in class `BeanDeserializerBase`

    - #### finishBuild

          protected final java.lang.Object finishBuild(DeserializationContext ctxt,
                                     java.lang.Object builder)
                                                throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### deserialize

          public final java.lang.Object deserialize(com.fasterxml.jackson.core.JsonParser p,
                                     DeserializationContext ctxt)
                                             throws java.io.IOException

      Main deserialization method for bean-based objects (POJOs).
      Specified by:
        `deserialize` in class `JsonDeserializer<java.lang.Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `java.io.IOException`

    - #### deserialize

          public java.lang.Object deserialize(com.fasterxml.jackson.core.JsonParser p,
                                     DeserializationContext ctxt,
                                     java.lang.Object builder)
                                       throws java.io.IOException

      Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.
      Overrides:
        `deserialize` in class `JsonDeserializer<java.lang.Object>`
      Throws:
        `java.io.IOException`

    - #### _deserialize

          protected final java.lang.Object _deserialize(com.fasterxml.jackson.core.JsonParser p,
                                      DeserializationContext ctxt,
                                      java.lang.Object builder)
                                                 throws java.io.IOException,
                                                        com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeFromObject

          public java.lang.Object deserializeFromObject(com.fasterxml.jackson.core.JsonParser p,
                                               DeserializationContext ctxt)
                                                 throws java.io.IOException,
                                                        com.fasterxml.jackson.core.JsonProcessingException

      General version used when handling needs more advanced features.
      Specified by:
        `deserializeFromObject` in class `BeanDeserializerBase`
      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### _deserializeUsingPropertyBased

          protected final java.lang.Object _deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser p,
                                                        DeserializationContext ctxt)
                                                                   throws java.io.IOException,
                                                                          com.fasterxml.jackson.core.JsonProcessingException

      Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters. The trick is that values for creator method need to be buffered, first; and due to non-guaranteed ordering possibly some other properties as well.
      Specified by:
        `_deserializeUsingPropertyBased` in class `BeanDeserializerBase`
      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeWithView

          protected final java.lang.Object deserializeWithView(com.fasterxml.jackson.core.JsonParser p,
                                             DeserializationContext ctxt,
                                             java.lang.Object bean,
                                             java.lang.Class<?> activeView)
                                                        throws java.io.IOException,
                                                               com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeWithUnwrapped

          protected java.lang.Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p,
                                                  DeserializationContext ctxt)
                                                       throws java.io.IOException,
                                                              com.fasterxml.jackson.core.JsonProcessingException

      Method called when there are declared "unwrapped" properties which need special handling
      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeWithUnwrapped

          protected java.lang.Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p,
                                                  DeserializationContext ctxt,
                                                  java.lang.Object bean)
                                                       throws java.io.IOException,
                                                              com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeUsingPropertyBasedWithUnwrapped

          protected java.lang.Object deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser p,
                                                                    DeserializationContext ctxt)
                                                                         throws java.io.IOException,
                                                                                com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeWithExternalTypeId

          protected java.lang.Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p,
                                                       DeserializationContext ctxt)
                                                            throws java.io.IOException,
                                                                   com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeWithExternalTypeId

          protected java.lang.Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p,
                                                       DeserializationContext ctxt,
                                                       java.lang.Object bean)
                                                            throws java.io.IOException,
                                                                   com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### deserializeUsingPropertyBasedWithExternalTypeId

          protected java.lang.Object deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p,
                                                                         DeserializationContext ctxt)
                                                                              throws java.io.IOException,
                                                                                     com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`